SystemOrganization addCategory: #FuelPlatform!

Object subclass: #FLExtensionWrapper
	instanceVariableNames: 'targetClass method selector isSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLExtensionWrapper class methodsFor: 'instance-creation' stamp: 'MaxLeske 2/19/2016 12:42'!
fromPragma: aPragma
	^ self new
		initializeWithPragma: aPragma;
		yourself! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:32'!
compileInTarget
	| methodSelector source |
	source := self method methodClass theNonMetaClass
		perform: self method selector
		withArguments: (1 to: self method selector numArgs) asArray.
	"actual selector may be different from the one used to store the source"
	methodSelector := self targetClass compile: source.
	self targetClass organization
		classify: self selector
		under: self extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:03'!
copySelector: aSelector ofMethod: aCompiledMethod toClass: aClass
	aClass
		addAndClassifySelector: aSelector
		withMethod: aCompiledMethod copy
		inProtocol: self extensionProtocolName
		notifying: nil! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/20/2016 16:28'!
copyToTarget
	self targetClass
		addAndClassifySelector: self selector
		withMethod: self method copy
		inProtocol: self extensionProtocolName
		notifying: nil! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'TravisCI 2/20/2016 14:12'!
extensionProtocolName
	^ FLPlatform extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:29'!
initializeWithPragma: aPragma
	| argumentNamesAndValues |
	argumentNamesAndValues := self readArgumentsFrom: aPragma.
	self
		method: aPragma method copy;
		selector: (self
			readSelectorFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second);
		isSource: (self
			readIsSourceFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second);
		targetClass: (self
			readTargetClassFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second)! !

!FLExtensionWrapper methodsFor: 'operations' stamp: 'MaxLeske 2/20/2016 15:58'!
install
	self targetClass ifNil: [ ^ self ].
	
	self isSource ifTrue: [ ^ self compileInTarget ].
	self selector = self method selector ifFalse: [ ^ self renameAndCompileInTarget ].
	
	self copyToTarget! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
isSource
	^ isSource! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
isSource: aBoolean
	isSource := aBoolean! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
method
	^ method! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
method: aCompiledMethod
	method := aCompiledMethod! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:21'!
readArgumentsFrom: aPragma
	^ {
		aPragma key keywords.
		aPragma arguments }! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:22'!
readIsSourceFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	| index |
	index := argumentNames
		indexOf: 'isSource:'
		ifAbsent: [ ^ false ].
	
	^ argumentValues at: index! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:22'!
readSelectorFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	| index |
	index := argumentNames
		indexOf: 'selector:'
		ifAbsent: [ ^ aPragma selector ].
	
	^ argumentValues at: index! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/20/2016 15:16'!
readTargetClassFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	| class |
	class := Smalltalk
		at: (argumentValues at: (argumentNames indexOf: 'flExtensionOf:'))
		ifAbsent: [ ^ nil ].
		
	^ (aPragma method pragmas anySatisfy: [ :pragma |
		pragma key = #flExtensionClassSide ])
			ifTrue: [ class class ]
			ifFalse: [ class ]! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:12'!
renameAndCompileInTarget
	| source methodSelector |
	"We need to change the selector and Squeak has no easy
	way of doing that..."
	source := (self method methodClass decompilerClass new
		decompile: self selector
		in: self method methodClass
		method: self method methodForDecompile)
			decompileString.
	"Fix a compiler glitch that by adding a space between selector and pragma
	end for certain selectors"
	source := source
		copyReplaceAll: 'selector: #=>', String cr
		with: 'selector: #= >', String cr.
	methodSelector := self targetClass compile: source.
	self targetClass organization
		classify: methodSelector
		under: self extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 12:41'!
selector
	^ selector! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
selector: aSymbol
	selector := aSymbol! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:42'!
targetClass
	^ targetClass! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:42'!
targetClass: aClass
	targetClass := aClass! !

Object subclass: #FLPlatform
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLPlatform subclass: #FLPharoPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLPharoPlatform subclass: #FLPharo4Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLPharo4Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo4' ]! !

!FLPharo4Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/20/2016 16:15'!
fileNamed: aFileame readStreamDo: aBlock
	aFileame asFileReference writeStreamDo: [ :stream |
		stream binary.
		aBlock value: stream ]! !

!FLPharo4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:09'!
isBigEndian
	^Smalltalk isBigEndian! !

!FLPharo4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:10'!
isSpur
	^ false! !

FLPharoPlatform subclass: #FLPharo5Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLPharo5Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo5' ]! !

!FLPharo5Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/20/2016 16:15'!
fileNamed: aFilename readStreamDo: aBlock
	((Smalltalk at: #File) named: aFilename) readStreamDo: [ :stream |
		stream binary.
		aBlock value: stream ]! !

!FLPharo5Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/20/2016 16:17'!
fileNamed: aFilename writeStreamDo: aBlock
	((Smalltalk at: #File) named: aFilename) writeStreamDo: [ :stream |
		stream binary.
		aBlock value: stream ]! !

!FLPharo5Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:08'!
isBigEndian
	^ (Smalltalk at: #EndianDetector) isBigEndian! !

!FLPharoPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 17:30'!
addHacks
	super addHacks.
	
	self
		addNativeBoostComponents;
		addPackageManifest! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 13:42'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		category: self hacksCategoryName! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 13:42'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'TravisCI 2/20/2016 14:16'!
isResponsibleForCurrentPlatform
	^ SystemVersion current version beginsWith: 'Pharo'! !

!FLPharoPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:10'!
isSpur
	^ true! !

!FLPharoPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 2/21/2016 09:56'!
useAuthor: aString during: aBlock
	(Smalltalk at: #Author)
		useAuthor: aString
		during: aBlock! !

!FLPlatform class methodsFor: 'private-extensions' stamp: 'MaxLeske 2/19/2016 13:00'!
addExtensions
	self extensionPragmas do: [ :pragma |
		(FLExtensionWrapper fromPragma: pragma) install ]! !

!FLPlatform class methodsFor: 'operations' stamp: 'MaxLeske 2/21/2016 09:53'!
addHacks
	self current
		useAuthor: 'Fuel'
		during: [ self basicAddHacks ]! !

!FLPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/21/2016 09:52'!
basicAddHacks
	self addExtensions! !

!FLPlatform class methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 14:52'!
current
	^ Current ifNil: [ Current := self detectPlatform ]! !

!FLPlatform class methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 11:14'!
detectPlatform
	| matches mostSpecific |
	matches := self allSubclasses 
		select: [ :class | class isResponsibleForCurrentPlatform ].
	mostSpecific := matches first.
	matches do: [ :class |
		class allSubclasses size < mostSpecific allSubclasses size ifTrue: [
			mostSpecific := class ] ].
	
	^ mostSpecific new! !

!FLPlatform class methodsFor: 'private-extensions' stamp: 'Fuel 2/21/2016 13:04'!
extensionPragmas
	| pragmas |
	pragmas := Dictionary new.
	#(
		flExtensionOf:
		flExtensionOf:selector:
		flExtensionOf:selector:isSource:
		flExtensionOf:isSource:) do: [ :selector |
			| stop |
			stop := false.
			self class withAllSuperclassesDo: [ :class |
				stop ifFalse: [
					Pragma withPragmasIn: class do:  [ :pragma |
						(pragma keyword = selector and: [
							"don't collect overridden methods"
							(pragmas includesKey: pragma selector) not ]) ifTrue: [
								pragmas
									at: pragma selector
									put: pragma ] ].
						FLPlatform class = class ifTrue: [ stop := true ] ] ] ].
			
	^ pragmas values! !

!FLPlatform class methodsFor: 'accessing' stamp: 'TravisCI 2/20/2016 14:12'!
extensionProtocolName
	^ '*FuelPlatformExtensions'! !

!FLPlatform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:23'!
fixMetacello! !

!FLPlatform class methodsFor: 'accessing' stamp: 'TravisCI 2/20/2016 14:11'!
hacksCategoryName
	^ 'FuelPlatformHacks'! !

!FLPlatform class methodsFor: 'class initialization' stamp: 'MaxLeske 2/21/2016 13:29'!
initialize
	"initialize will only be sent to the defining class, not its subclasses"
	self current class addHacks! !

!FLPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:54'!
isResponsibleForCurrentPlatform
	^ self subclassResponsibility! !

!FLPlatform class methodsFor: 'private-convenience' stamp: 'TravisCI 2/20/2016 14:11'!
removeModifications
	(PackageInfo named: self extensionProtocolName) extensionMethods do: [ :methodReference |
		methodReference actualClass removeSelector: methodReference selector ].
	(PackageInfo named: self hacksCategoryName) in: [ :hacks |
		hacks classes do: [ :classOrTrait |
			classOrTrait removeFromSystem ].
		PackageOrganizer default  unregisterPackage: hacks ].
	SystemOrganizer default removeCategory: self hacksCategoryName! !

!FLPlatform class methodsFor: 'private-convenience' stamp: 'MaxLeske 2/21/2016 10:15'!
reset
	Current := nil! !

!FLPlatform methodsFor: 'operations' stamp: 'TravisCI 2/20/2016 14:40'!
addHacks
	self class addHacks! !

!FLPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:29'!
fileNamed: aFilename readStreamDo: aBlock
	self subclassResponsibility! !

!FLPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:29'!
fileNamed: aFilename writeStreamDo: aBlock
	self subclassResponsibility! !

!FLPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:59'!
isBigEndian
	^ self subclassResponsibility! !

!FLPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:11'!
isSpur
	^ true! !

!FLPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 2/21/2016 09:55'!
useAuthor: aString during: aBlock
	self subclassResponsibility! !

FLPlatform subclass: #FLSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLSqueakPlatform subclass: #FLSqueak43Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak43Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/21/2016 13:03'!
abstractBytecodeMessageAt: pc
	<flExtensionOf: #CompiledMethod>
	"Answer the abstract bytecode message at pc in the receiver."
	^[(InstructionStream new method: self pc: pc) interpretNextInstructionFor: nil]
		on: MessageNotUnderstood
		do: [:ex| ex message]! !

!FLSqueak43Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 13:02'!
abstractBytecodeMessagesDo: aBlock
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver."
	self method
		abstractBytecodeMessagesFrom: startpc
		to: self endPC
		do: aBlock'! !

!FLSqueak43Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/21/2016 13:03'!
abstractBytecodeMessagesFrom: startpc to: endpc do: aBlock
	<flExtensionOf: #CompiledMethod>
	"Evaluate aBlock with the sequence of abstract bytecodes from startpc through endpc in the receiver"
	| scanner |
	scanner := InstructionStream new method: self pc: startpc.
	[scanner pc <= endpc] whileTrue:
		[[scanner interpretNextInstructionFor: nil]
			on: MessageNotUnderstood
			do: [:ex| aBlock value: ex message]]! !

!FLSqueak43Platform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/21/2016 13:01'!
arguments
	<flExtensionOf: #ContextPart>
	"returns the arguments of a message invocation"
	
	| arguments numargs |
	numargs :=  self method numArgs.
	arguments := Array new: numargs.
	1 to: numargs do: [:i | arguments at: i put: (self tempAt: i) ].
	^ arguments! !

!FLSqueak43Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 13:02'!
blockCreationBytecodeMessage
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'blockCreationBytecodeMessage
	"Answer the abstract bytecode message that created the receiver."
	| blockCreationBytecodeSize |
	^self method abstractBytecodeMessageAt: startpc - (blockCreationBytecodeSize := 4)

	"(SortedCollection sortBlock: [:a :b| a compare: b caseSensitive: false]) sortBlock blockCreationBytecodeMessage"'! !

!FLSqueak43Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 13:02'!
endPC
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'endPC
	^self blockCreationBytecodeMessage arguments last + startpc - 1'! !

!FLSqueak43Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/21/2016 14:29'!
expectedFailures
	<flExtensionOf: #FLBasicSerializationTest>
	^ #(testConsiderCustomWideSymbolGlobal)! !

!FLSqueak43Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/21/2016 13:08'!
fuelEqualsForCompiledMethod: method
	<flExtensionOf: #CompiledMethod selector: #fuelEquals:>
	"Answer whether the receiver implements the same code as the argument, method.
	 Here ``same code'' means that if the receiver's source is compiled with the same
	 compiler it should produce the same sequence of bytecodes and literals, same
	 trailer and same properties.  Hence this definition of #= (only one of many plausible
	 definitions) can be used to quickly identify changes in the compiler's output."
	| numLits |
	method isCompiledMethod ifFalse: [^false].
	self size = method size ifFalse: [^false].
	self header = method header ifFalse: [^false]. "N.B. includes numLiterals comparison."
	self initialPC to: self endPC do:
		[:i | (self at: i) = (method at: i) ifFalse: [^false]].
	numLits := self numLiterals.
	1 to: numLits do:
		[:i| | lit1 lit2 |
		lit1 := self literalAt: i.
		lit2 := method literalAt: i.
		(lit1 == lit2 or: [lit1 literalEqual: lit2]) ifFalse:
			[(i = 1 and: [#(117 120) includes: self primitive])
				ifTrue:
					[lit1 isArray
						ifTrue:
							[(lit2 isArray and: [lit1 allButLast = lit2 allButLast]) ifFalse:
								[^false]]
						ifFalse: "ExternalLibraryFunction"
							[(lit1 analogousCodeTo: lit2) ifFalse:
								[^false]]]
				ifFalse:
					[i = (numLits - 1)
						ifTrue: "properties"
							[(self properties analogousCodeTo: method properties)
								ifFalse: [^false]]
						ifFalse: "last literal (methodClassAssociation) of class-side methods is not unique"
							[(i = numLits
							 and: [lit1 isVariableBinding
							 and: [lit2 isVariableBinding
							 and: [lit1 key == lit2 key
							 and: [lit1 value == lit2 value]]]]) ifFalse:
								[^false]]]]].
	^true! !

!FLSqueak43Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 13:03'!
isClean
	<flExtensionOf: #BlockClosure>
	"Answer if the receiver does not close-over any variables other than globals, and does
	 not ^-return (does not close over the home context).  Clean blocks are amenable to
	 being created at compile-time."
	self numCopiedValues > 0 ifTrue:
		[^false].
	self abstractBytecodeMessagesDo:
		[:msg|
		(#(	pushReceiver
			pushReceiverVariable: popIntoReceiverVariable: storeIntoReceiverVariable:
			methodReturnConstant: methodReturnReceiver methodReturnTop)
				includes: msg selector) ifTrue:
					[^false]].
	^true! !

!FLSqueak43Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/21/2016 13:08'!
isEqualRegardlessTrailerTo: aCompiledMethod
	<flExtensionOf: #CompiledMethod>
	^ (self copyWithTrailerBytes: CompiledMethodTrailer empty) fuelEquals: (aCompiledMethod copyWithTrailerBytes: CompiledMethodTrailer empty)! !

!FLSqueak43Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/21/2016 13:01'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak4.3' ]! !

!FLSqueak43Platform class methodsFor: 'private-extensions-date' stamp: 'MaxLeske 2/21/2016 13:17'!
materializeFromForDate: aDecoder
	<flExtensionOf: #Date selector: #materializeFrom:>
	<flExtensionClassSide>
	^ self 
		starting: (DateAndTime materializeFrom: aDecoder) 
		duration: (Duration days: 1)! !

!FLSqueak43Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/21/2016 13:09'!
testDateOffsets
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 1 hour.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLSqueak43Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/21/2016 13:09'!
testDateOffsetsChanging
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	self serialize:object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour! !

FLSqueakPlatform subclass: #FLSqueak44Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak44Platform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/21/2016 10:13'!
arguments
	<flExtensionOf: #ContextPart>
	"returns the arguments of a message invocation"
	
	| arguments numargs |
	numargs :=  self method numArgs.
	arguments := Array new: numargs.
	1 to: numargs do: [:i | arguments at: i put: (self tempAt: i) ].
	^ arguments! !

!FLSqueak44Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/21/2016 10:15'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak4.4' ]! !

FLSqueakPlatform subclass: #FLSqueak4Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLSqueak4Platform subclass: #FLSqueak45Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak45Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 17:31'!
abstractBytecodeMessageAt: pc
	<flExtensionOf: #CompiledMethod>
	"Answer the abstract bytecode message at pc in the receiver."
	^[(InstructionStream new method: self pc: pc) interpretNextInstructionFor: nil]
		on: MessageNotUnderstood
		do: [:ex| ex message]! !

!FLSqueak45Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/20/2016 17:27'!
abstractBytecodeMessagesDo: aBlock
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver."
	self method
		abstractBytecodeMessagesFrom: startpc
		to: self endPC
		do: aBlock'! !

!FLSqueak45Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 17:30'!
abstractBytecodeMessagesFrom: startpc to: endpc do: aBlock
	<flExtensionOf: #CompiledMethod>
	"Evaluate aBlock with the sequence of abstract bytecodes from startpc through endpc in the receiver"
	| scanner |
	scanner := InstructionStream new method: self pc: startpc.
	[scanner pc <= endpc] whileTrue:
		[[scanner interpretNextInstructionFor: nil]
			on: MessageNotUnderstood
			do: [:ex| aBlock value: ex message]]! !

!FLSqueak45Platform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/20/2016 17:32'!
arguments
	<flExtensionOf: #ContextPart>
	"returns the arguments of a message invocation"
	
	| arguments numargs |
	numargs :=  self method numArgs.
	arguments := Array new: numargs.
	1 to: numargs do: [:i | arguments at: i put: (self tempAt: i) ].
	^ arguments! !

!FLSqueak45Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/20/2016 17:28'!
blockCreationBytecodeMessage
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'blockCreationBytecodeMessage
	"Answer the abstract bytecode message that created the receiver."
	| blockCreationBytecodeSize |
	^self method abstractBytecodeMessageAt: startpc - (blockCreationBytecodeSize := 4)

	"(SortedCollection sortBlock: [:a :b| a compare: b caseSensitive: false]) sortBlock blockCreationBytecodeMessage"'! !

!FLSqueak45Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/20/2016 17:28'!
endPC
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'endPC
	^self blockCreationBytecodeMessage arguments last + startpc - 1'! !

!FLSqueak45Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/20/2016 17:26'!
isClean
	<flExtensionOf: #BlockClosure>
	"Answer if the receiver does not close-over any variables other than globals, and does
	 not ^-return (does not close over the home context).  Clean blocks are amenable to
	 being created at compile-time."
	self numCopiedValues > 0 ifTrue:
		[^false].
	self abstractBytecodeMessagesDo:
		[:msg|
		(#(	pushReceiver
			pushReceiverVariable: popIntoReceiverVariable: storeIntoReceiverVariable:
			methodReturnConstant: methodReturnReceiver methodReturnTop)
				includes: msg selector) ifTrue:
					[^false]].
	^true! !

!FLSqueak45Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/20/2016 17:23'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak4.5' ]! !

FLSqueak4Platform subclass: #FLSqueak46Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak46Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:25'!
fixMetacello
	super fixMetacello.
	
	self fixSystemVersion! !

!FLSqueak46Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 11:19'!
fixSystemVersion
	"This is ridiculous but until release the 4.6 image seems to identify itself as 4.5 (WTF!!)"
	(Smalltalk imageName includesSubString: '4.6') ifFalse: [ ^ self ].

	SystemVersion current version: 'Squeak4.6'! !

!FLSqueak46Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 11:20'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		(SystemVersion current version beginsWith: 'Squeak4.6') or: [
			"See #fixSystemVersion"
			(Smalltalk imageName includesSubString: '4.6') ] ]! !

!FLSqueak4Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'TravisCI 2/20/2016 23:14'!
expectedFailuresForFLBasicSerializationTest
	<flExtensionOf: #FLBasicSerializationTest selector: #expectedFailures>
	^ #(testConsiderCustomWideSymbolGlobal testWideStringGlobal testWideStringClassName)! !

!FLSqueak4Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:28'!
fixMetacello
	super fixMetacello.
	
	self fixPlatformAttributes! !

!FLSqueak4Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:28'!
fixPlatformAttributes
	| versions |
	versions := { 'Squeak4.1'. 'Squeak4.2'. 'Squeak4.3'. 'Squeak4.4'. 'Squeak4.5'. 'Squeak4.6' }.
		
	Smalltalk 
		at: #MetacelloSqueakPlatform
		ifPresent: [ :platform |
			(Smalltalk at: #Utilities) setAuthorInitials: 'MaxLeske'.
			(Smalltalk at: #MetacelloSqueakPlatform) compile: (self newSqueakPlatformAttributesSourceFrom: versions).
			(Smalltalk at: #Utilities) setAuthorInitials: '' ]! !

!FLSqueak4Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak4' ]! !

!FLSqueak4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:12'!
isSpur	
	^ false! !

FLSqueakPlatform subclass: #FLSqueak5Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak5Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:58'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak5' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-string' stamp: 'MaxLeske 2/19/2016 09:26'!
=> anObject
	<flExtensionOf: #String>	
	^ anObject isBehavior
		ifTrue: [ClassBinding key: self value: anObject]
		ifFalse: [Global key: self value: anObject]! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:40'!
addClusters
	Smalltalk
		at: #FLMethodContextCluster
		ifPresent: [ :x | ^ self ].
		
	FLVariableObjectCluster subclass: #FLMethodContextCluster
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addContext
	Smalltalk
		at: #Context
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Context
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addEnvironment
	"Don't name the category 'Fuel-Hacks'. That category will be nuked on load"	
	Smalltalk
		at: #Environment
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Environment
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 2/20/2016 14:56'!
addInstVarNamed: aString
	<flExtensionOf: #Class>
	"Add the argument, aString, as one of the receiver's instance variables."
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString, ' ', aString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ :manifest | ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addTraits
	(Smalltalk classOrTraitNamed: #TClass) ifNil: [
		Trait 
			named: #TClass
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TClassDescription) ifNil: [
		Trait 
			named: #TClassDescription
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TBehavior) ifNil: [
		Trait 
			named: #TBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TPureBehavior) ifNil: [
		Trait 
			named: #TPureBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TApplyingOnClassSide) ifNil: [
		Trait 
			named: #TApplyingOnClassSide
			uses: {}
			category: self hacksCategoryName ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-symbol' stamp: 'MaxLeske 2/20/2016 15:43'!
asMethodPreamble
	<flExtensionOf: #Symbol>
	self numArgs = 0 ifTrue: [ ^self asString].
	^ String streamContents: [ :str | 
		self keywords doWithIndex: [ :each :index | 
				str
					nextPutAll: each;
					nextPutAll: ' var' , index asString ] ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/19/2016 09:25'!
assertWellMaterializedInto: aMethodContext in: aTestCase
	<flExtensionOf: #MethodContext isSource: true>
	^ 'assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]'! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/21/2016 09:52'!
basicAddHacks
	super basicAddHacks.
	
	self
		addTraits;
		addEnvironment;
		addNativeBoostComponents;
		addContext;
		addClusters;
		addPackageManifest! !

!FLSqueakPlatform class methodsFor: 'private-extensions-protoobject' stamp: 'Maxleske 2/20/2016 18:41'!
basicIdentityHashForProtoObject
	<flExtensionOf: #ProtoObject selector: #basicIdentityHash>
	^ self identityHash! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:04'!
bytecodesHash
	<flExtensionOf: #CompiledMethod>
	"Answer a 16-bit checksum of the bytecodes."

	^ self crc16from: self initialPC to: self endPC! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:37'!
cleanCopy 
	<flExtensionOf: #MethodContext isSource: true>
	^ 'cleanCopy 
	^ self class 
		sender: nil 
		receiver: receiver 
		method: method
		arguments: #()'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:41'!
codeForNoSource
	<flExtensionOf: #CompiledMethod>
	"this is the marker we use for method that have no source"
	^ String streamContents: [:str |
		str 
			nextPutAll: self selector asMethodPreamble;
			cr;tab;
			nextPutAll: 'self methodHasNoSourceCode' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-bytearray' stamp: 'MaxLeske 2/20/2016 15:07'!
crc16from: start to: end
	<flExtensionOf: #ByteArray>
	"Compute a 16 bit cyclic redundancy check on the specified interval."

	| crc |
	crc := 0.
	start to: end do: [:i |
		crc := (crc bitShift: -8) bitXor: (
		 #(	16r0000	16rC0C1	16rC181	16r0140	16rC301	16r03C0	16r0280	16rC241
			16rC601	16r06C0	16r0780	16rC741	16r0500	16rC5C1	16rC481	16r0440
			16rCC01	16r0CC0	16r0D80	16rCD41	16r0F00	16rCFC1	16rCE81	16r0E40
			16r0A00	16rCAC1	16rCB81	16r0B40	16rC901	16r09C0	16r0880	16rC841
			16rD801	16r18C0	16r1980	16rD941	16r1B00	16rDBC1	16rDA81	16r1A40
			16r1E00	16rDEC1	16rDF81	16r1F40	16rDD01	16r1DC0	16r1C80	16rDC41
			16r1400	16rD4C1	16rD581	16r1540	16rD701	16r17C0	16r1680	16rD641
			16rD201	16r12C0	16r1380	16rD341	16r1100	16rD1C1	16rD081	16r1040
			16rF001	16r30C0	16r3180	16rF141	16r3300	16rF3C1	16rF281	16r3240
			16r3600	16rF6C1	16rF781	16r3740	16rF501	16r35C0	16r3480	16rF441
			16r3C00	16rFCC1	16rFD81	16r3D40	16rFF01	16r3FC0	16r3E80	16rFE41
			16rFA01	16r3AC0	16r3B80	16rFB41	16r3900	16rF9C1	16rF881	16r3840
			16r2800	16rE8C1	16rE981	16r2940	16rEB01	16r2BC0	16r2A80	16rEA41
			16rEE01	16r2EC0	16r2F80	16rEF41	16r2D00	16rEDC1	16rEC81	16r2C40
			16rE401	16r24C0	16r2580	16rE541	16r2700	16rE7C1	16rE681	16r2640
			16r2200	16rE2C1	16rE381	16r2340	16rE101	16r21C0	16r2080	16rE041
			16rA001	16r60C0	16r6180	16rA141	16r6300	16rA3C1	16rA281	16r6240
			16r6600	16rA6C1	16rA781	16r6740	16rA501	16r65C0	16r6480	16rA441
			16r6C00	16rACC1	16rAD81	16r6D40	16rAF01	16r6FC0	16r6E80	16rAE41
			16rAA01	16r6AC0	16r6B80	16rAB41	16r6900	16rA9C1	16rA881	16r6840
			16r7800	16rB8C1	16rB981	16r7940	16rBB01	16r7BC0	16r7A80	16rBA41
			16rBE01	16r7EC0	16r7F80	16rBF41	16r7D00	16rBDC1	16rBC81	16r7C40
			16rB401	16r74C0	16r7580	16rB541	16r7700	16rB7C1	16rB681	16r7640
			16r7200	16rB2C1	16rB381	16r7340	16rB101	16r71C0	16r7080	16rB041
			16r5000	16r90C1	16r9181	16r5140	16r9301	16r53C0	16r5280	16r9241
			16r9601	16r56C0	16r5780	16r9741	16r5500	16r95C1	16r9481	16r5440
			16r9C01	16r5CC0	16r5D80	16r9D41	16r5F00	16r9FC1	16r9E81	16r5E40
			16r5A00	16r9AC1	16r9B81	16r5B40	16r9901	16r59C0	16r5880	16r9841
			16r8801	16r48C0	16r4980	16r8941	16r4B00	16r8BC1	16r8A81	16r4A40
			16r4E00	16r8EC1	16r8F81	16r4F40	16r8D01	16r4DC0	16r4C80	16r8C41
			16r4400	16r84C1	16r8581	16r4540	16r8701	16r47C0	16r4680	16r8641
			16r8201	16r42C0	16r4380	16r8341	16r4100	16r81C1	16r8081	16r4040)
			 at: ((crc bitXor: (self byteAt: i)) bitAnd: 16rFF) + 1) ].
	^crc! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
defaultTimeout
	<flExtensionOf: #FLSerializationTest>
	"We have some long running tests which will be terminated by Squeaks
	implementation of TestCase>>runCase. Increase the default fro 5 to 60 seconds"
	
	^ 60 "seconds"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 FileDirectory default deleteFileNamed: aFilename! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:05'!
duringTestCompileSilently: code
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code storeSource: storeSource
	<flExtensionOf: #ClassDescription>
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/21/2016 09:59'!
duringTestCompileSilently: code storeSource: storeSource classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ FLPlatform current 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '''' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-gradientfillstyle' stamp: 'MaxLeske 2/19/2016 10:28'!
equals: anGradientFillStyle
	<flExtensionOf: #GradientFillStyle selector: #= >
	"Answer whether equal."

	^ self pixelRamp == anGradientFillStyle pixelRamp "LRU should make identity equal"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-collection' stamp: 'MaxLeske 2/20/2016 14:51'!
flatCollect: aBlock
	<flExtensionOf: #Collection>
	"Evaluate aBlock for each of the receiver's elements and answer the
	list of all resulting values flatten one level. Assumes that aBlock returns some kind
	of collection for each element. Equivalent to the lisp's mapcan"
	
	| stream |
	self isEmpty ifTrue: [ ^ self copy ].
	stream := (self species new: 0) writeStream.
	self do: [ :each | stream nextPutAll: (aBlock value: each) ].
	^ stream contents! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:35'!
fuelAcceptForEnvironment: aGeneralMapper
	<flExtensionOf: #Environment selector: #fuelAccept:>
	"serialize all instances except for <Smalltalk globals>"
	^ self == Smalltalk globals 
		ifFalse: [ super fuelAccept: aGeneralMapper ]
		ifTrue: [ aGeneralMapper visitHookPrimitive: self ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 16:26'!
fuelAcceptForMethodContext: aGeneralMapper
	<flExtensionOf: #MethodContext selector: #fuelAccept:>
	^ aGeneralMapper visitMethodContext: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelIgnoredInstanceVariableNames
	<flExtensionOf: #Behavior>
	"Indicates which variables have to be ignored during serialization."

	^#()! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelNew
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelNew: sizeRequested
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew: sizeRequested! !

!FLSqueakPlatform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/20/2016 15:12'!
fuelValueWithoutNotifications
	<flExtensionOf: #BlockClosure>
	SystemChangeNotifier uniqueInstance doSilently: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethodtrailer' stamp: 'MaxLeske 2/20/2016 15:39'!
hasSource
	<flExtensionOf: #CompiledMethodTrailer isSource: true>
	^ 'hasSource
	^ kind == #EmbeddedSourceQCompress or: [ kind == #EmbeddedSourceZip ]'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:53'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	<flExtensionOf: #MethodContext isSource: true>
	^ 'initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/20/2016 14:57'!
instVarIndexFor: instVarName
	<flExtensionOf: #ClassDescription>
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
		ifTrue: [0]
		ifFalse: [instanceVariables indexOf: instVarName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [superclass instVarIndexFor: instVarName]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
instanceVariableNamesDo: anUnaryBlock
	<flExtensionOf: #ClassDescription>
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:04'!
isDoIt
	<flExtensionOf: #CompiledMethod>
	^ self selector isDoIt.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:40'!
isNamedPrimitive
	<flExtensionOf: #CompiledMethod>
	^ self primitive = 117! !

!FLSqueakPlatform class methodsFor: 'testing' stamp: 'TravisCI 2/20/2016 14:17'!
isResponsibleForCurrentPlatform
	^ SystemVersion current version beginsWith: 'Squeak'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/20/2016 15:08'!
julianDayNumberUTC
	<flExtensionOf: #DateAndTime isSource: true>
	^ 'julianDayNumberUTC
	^ jdn'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:39'!
materializeFromForEnvironment: aDecoder
	<flExtensionOf: #Environment selector: #materializeFrom:>
	<flExtensionClassSide>
	"Answer my well-known instance"

	^ (Smalltalk at: #Environment) default! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
methodNamed: aSelector
	<flExtensionOf: #Behavior>
	^ self methodDict at: aSelector! !

!FLSqueakPlatform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/20/2016 15:47'!
newFromFrameSize: aFrameSize
	<flExtensionOf: #ContextPart>
	<flExtensionClassSide>
	^ super basicNew: aFrameSize! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
newName
	<flExtensionOf: #ClassFactoryForTestCase>
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!FLSqueakPlatform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 13:43'!
newSqueakPlatformAttributesSourceFrom: aCollection
	^ String streamContents: [ :stream | 
		stream nextPutAll: 'defaultPlatformAttributes
	| attributes versionString |
	attributes := OrderedCollection with: #squeakCommon with: #squeak.
	Smalltalk
		at: #SystemVersion
		ifPresent: [:cl | 
			versionString := cl current version.
			(versionString beginsWith: ''Squeak3.10'')
				ifTrue: [attributes add: #''squeak3.10.x''].
			(versionString beginsWith: ''Squeak4'')
				ifTrue: [attributes add: #''squeak4.x''.'.
		aCollection do: [ :version |
			stream
				nextPutAll: '(versionString beginsWith: ''';
				nextPutAll:  version;
				nextPutAll: ''') ifTrue: [ attributes add: #''';
				nextPutAll: version asLowercase;
				nextPutAll: '.x''] ifFalse: [ ' ].
		stream 
			nextPutAll: (String newFrom: ((1 to: aCollection size + 2) collect: [ :i | $] ]));
			nextPutAll: '. ^ attributes' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
newSubclassNamed: nameString of: aClass  instanceVariableNames: ivNamesString classVariableNames: classVarsString
	<flExtensionOf: #FLSerializationTest>
	| class |
	SystemChangeNotifier uniqueInstance doSilently: [
		class := aClass
			subclass: nameString asSymbol
			instanceVariableNames: ivNamesString
			classVariableNames:  classVarsString
			poolDictionaries: ''
			category: self classFactory defaultCategory
	].
	self classFactory createdClasses add: class.
	^ class! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/20/2016 14:50'!
reduceRight: aBlock
	<flExtensionOf: #SequenceableCollection>
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := Array new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sourcefilearray' stamp: 'MaxLeske 2/20/2016 15:18'!
remoteStringAt: sourcePointer
	<flExtensionOf: #SourceFileArray>
	| filePosition fileIndex |
	fileIndex := self fileIndexFromSourcePointer: sourcePointer.
	filePosition := self filePositionFromSourcePointer: sourcePointer.	

	^ RemoteString newFileNumber: fileIndex position: filePosition! !

!FLSqueakPlatform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 2/20/2016 14:56'!
removeInstVarNamed: aString
	<flExtensionOf: #Class>
	"Remove the argument, aString, as one of the receiver's instance variables."

	| newInstVarString |
	(self instVarNames includes: aString)
		ifFalse: [self error: aString , ' is not one of my instance variables'].
	newInstVarString := ''.
	(self instVarNames copyWithout: aString) do: 
		[:varName | newInstVarString := newInstVarString , ' ' , varName].
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: newInstVarString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
renameSilently: aName
	<flExtensionOf: #ClassDescription>
	 [ self rename: aName] fuelValueWithoutNotifications! !

!FLSqueakPlatform class methodsFor: 'private-extensions-date' stamp: 'MaxLeske 2/20/2016 16:29'!
serializeOnForDate: anEncoder
	<flExtensionOf: #Date selector: #serializeOn: isSource: true>
	^ 'serializeOn: anEncoder
	start serializeOn: anEncoder'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/20/2016 17:03'!
serializeOnForDateAndTime: anEncoder
	<flExtensionOf: #DateAndTime selector: #serializeOn:>
	anEncoder 
		encodeUint32: self julianDayNumberUTC;
		encodeUint32: self nanoSecond;
		encodeInt24: self secondsSinceMidnight;
		encodeInt24: self offset asSeconds;
		encodeInt32: self offset nanoSeconds.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:28'!
serializeOnForEnvironment: anEncoder
	<flExtensionOf: #Environment selector: #serializeOn:>
	"Do nothing"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-testcase' stamp: 'MaxLeske 2/20/2016 15:49'!
skip
	<flExtensionOf: #TestCase>! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:40'!
sourceCode
	<flExtensionOf: #CompiledMethod>
	"Retrieve or reconstruct the source code for this method."
	| trailer source |
	trailer := self trailer.
	trailer sourceCode ifNotNil: [:code | ^ code ].
	trailer hasSourcePointer ifFalse: [^ self codeForNoSource].

	"Situation normal;  read the sourceCode from the file"
	source := [self getSourceFromFile]
				on: Error
				do: [ :ex | ex return: nil].
	source isEmptyOrNil ifTrue: [^ self codeForNoSource].			
	^source! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/20/2016 14:50'!
sum: aBlock
	<flExtensionOf: #SequenceableCollection>
	"This is implemented using a variant of the normal inject:into: pattern. 
	The reason for this is that it is not known whether we're in the normal 
	number line, i.e. whether 0 is a good initial value for the sum. 
	Consider a collection of measurement objects, 0 would be the unitless 
	value and would not be appropriate to add with the unit-ed objects."
	| sum sample |
	sample := aBlock value: self anyOne.
	sum := self inject: sample into: [ :previousValue :each |  previousValue + (aBlock value: each) ].
	^ sum - sample! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDown
	<flExtensionOf: #FLSerializationTest>
	super tearDown.
	"Traits should be cleaned before classFactory because it seems class factory only knows how to clean classes, not traits."
	self tearDownTraits.
	self tearDownClassFactory.
	self tearDownGlobalVariables.
	self tearDownInstanceVariables! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDownInstanceVariables
	<flExtensionOf: #FLSerializationTest>
	self class withAllSuperclasses do: [ :class |
		class = TestCase ifTrue: [ ^ self ].
		
		class instVarNames do: [ :varName |
			self 
				instVarNamed: varName
				put: nil ] ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:53'!
tempNamed: aName
	<flExtensionOf: #MethodContext>
	^ self tempAt: (self tempNames indexOf: aName)! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:48'!
tempNamed: aName put: anObject
	<flExtensionOf: #MethodContext>
	^ self tempAt: (self tempNames indexOf: aName) put: anObject! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContext
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContextWithClosureAndSender
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext2  context2 |
	
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self.
	
! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContextWithNilPc
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:13'!
testContextWithSender
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1 context2 materializedContext1 |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	context2 := (MethodContext newForMethod: FLPair >> #method2).
	context2 
		initializeWith: 18 
		stackPtr: 1 
		method: FLPair >> #method2 
		receiver:  (FLPair new right: 5; left: 6) 
		sender: nil.

	context1 privSender:  context2.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:13'!
testContextWithTemp
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #methodWithTemp).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #methodWithTemp 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsets
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.

	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsetsChanging
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 1 hours.
	self serialize: object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flmigrationtest' stamp: 'MaxLeske 2/19/2016 09:14'!
testFormatFixedToVariable
	<flExtensionOf: #FLMigrationTest>
	"Tests that serializer can tolerate a format change from a *fixed* class to *weak/variable*.
	Notice, however, that the other way around (variable to fixed) doesn't work so far"
	
	| materialized |
	self serialize: FLPair new.
	materialized := [ self during: [ self materialized ] rename: FLPair as: FLWeakClassMock ]
		on: AttemptToWriteReadOnlyGlobal
		do: [ :ex | ex resume: true ].
	self assert: materialized size = 0! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/20/2016 16:15'!
fileNamed: aFilename readStreamDo: aBlock
	FileStream
		readOnlyFileNamed: aFilename
		do: [ :stream |
			stream binary.
			aBlock value: stream ]! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/20/2016 16:16'!
fileNamed: aFilename writeStreamDo: aBlock
	FileStream
		forceNewFileNamed: aFilename
		do: [ :stream |
			stream binary.
			aBlock value: stream ]! !

!FLSqueakPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:57'!
isBigEndian
	^ Smalltalk isBigEndian! !

!FLSqueakPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 2/21/2016 13:22'!
useAuthor: aString during: aBlock
	| previous utilities |
	utilities := (Smalltalk at:#Utilities).
	previous := utilities authorInitialsPerSe.
	utilities setAuthorInitials: aString.
	^ aBlock ensure: [ utilities setAuthorInitials: previous ]! !
FLPlatform initialize!
